'use strict';

exports.__esModule = true;
exports.default = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RenderReactCMS = (_temp2 = _class = function (_PureComponent) {
  _inherits(RenderReactCMS, _PureComponent);

  function RenderReactCMS() {
    var _temp, _this, _ret;

    _classCallCheck(this, RenderReactCMS);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.renderClientSide = function () {
      // bail if window is undefined, this means we're not client side
      if (typeof window === 'undefined') return;

      var _this$props = _this.props,
          html = _this$props.html,
          componentMap = _this$props.componentMap,
          componentAttribute = _this$props.componentAttribute,
          propsAttribute = _this$props.propsAttribute;


      _this.reactContainer.innerHTML = html;

      var nodeList = _this.reactContainer.querySelectorAll('[' + componentAttribute + ']');

      // loop over elements that match our componentAttribute `<div react-component>`
      Array.from(nodeList).forEach(function (node) {
        var component = componentMap[node.getAttribute(componentAttribute)];
        var props = _this.getPropsFromAttribute(node.getAttribute(propsAttribute));
        var element = _react2.default.createElement(component, props);

        // render the newly created element into the subtree using an ReactDOM api in order to maintain the tree
        _reactDom2.default.unstable_renderSubtreeIntoContainer(_this, element, node, function () {
          return node.replaceWith.apply(node, node.childNodes);
        });
      });
    }, _this.getPropsFromAttribute = function (componentProps) {
      var _this$props2 = _this.props,
          html = _this$props2.html,
          componentMap = _this$props2.componentMap,
          componentAttribute = _this$props2.componentAttribute,
          propsAttribute = _this$props2.propsAttribute,
          contextWrapper = _this$props2.contextWrapper,
          additionalProps = _objectWithoutProperties(_this$props2, ['html', 'componentMap', 'componentAttribute', 'propsAttribute', 'contextWrapper']);

      if (!componentProps) return additionalProps;

      var props = void 0;

      try {
        props = JSON.parse(componentProps);
      } catch (error) {
        console.warn('Error parsing ' + propsAttribute, componentProps);
      }

      return _extends({}, props, additionalProps);
    }, _this.renderServerSide = function () {
      // bail if window is defined .. this means we're not server side
      if ((typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object') return null;

      var ReactDOMServer = require('react-dom/server');
      var cheerio = require('cheerio');

      var _this$props3 = _this.props,
          html = _this$props3.html,
          componentAttribute = _this$props3.componentAttribute,
          propsAttribute = _this$props3.propsAttribute,
          componentProps = _this$props3.componentProps,
          componentMap = _this$props3.componentMap,
          contextWrapper = _this$props3.contextWrapper;


      var $ = cheerio.load(html);

      $('[' + componentAttribute + ']').each(function (i, element) {
        var component = componentMap[element.attribs[componentAttribute]];

        if (!component) return console.warn('Error, Component matching ' + component + ' not passed in');

        var props = _this.getPropsFromAttribute(element.attribs[propsAttribute]);

        var reactElement = _react2.default.createElement(component, props);

        var renderedReact = ReactDOMServer.renderServerSide(reactElement);

        if (contextWrapper) {
          // <RenderReact contextWrapper={(props) => <StaticRouter {...props} />} />
          reactElement = _react2.default.createElement(contextWrapper, null, reactElement);
        }

        $(element).replaceWith(renderedReact);
      });

      return $('body').html();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  RenderReactCMS.prototype.componentDidMount = function componentDidMount() {
    this.renderClientSide();
  };

  RenderReactCMS.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement('div', {
      ref: function ref(element) {
        return _this2.reactContainer = element;
      },
      dangerouslySetInnerHTML: { __html: this.renderServerSide() }
    });
  };

  return RenderReactCMS;
}(_react.PureComponent), _class.defaultProps = {
  componentAttribute: 'react-component',
  propsAttribute: 'react-props'
}, _temp2);
exports.default = RenderReactCMS;
module.exports = exports['default'];